<?php
// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// ##################### DEFINE IMPORTANT CONSTANTS #######################
define('THIS_SCRIPT', 'unreg_posts'); 

// #################### PRE-CACHE TEMPLATES AND DATA ######################
// get special data templates from the datastore
$specialtemplates = array(
	'smiliecache',
	'bbcodecache',
);

// pre-cache templates used by all actions
$globaltemplates = array(
        'unreg_post',
        'navbar',
        'unregpost_bits_header',
        'unregpost_bits',
		'pagenav',
);

// ########################## REQUIRE BACK-END ############################
require_once('./global.php');

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################
ini_set("display_errors",1);

$unreg_postbits = '';
$ip = '';
$user = '';
$nav = '';
$err = 0;

//check permissions
$arr_perm = explode(",", $vbulletin->userinfo['membergroupids']);
if ((5 != $permissions['usergroupid']) && (6 != $permissions['usergroupid']) && (7 != $permissions['usergroupid']) && 
!in_array(5, $arr_perm) && !in_array(6, $arr_perm) && !in_array(7, $arr_perm)) {
    print_no_permission();
}
else {
    //check pair "name-IP"
    if (isset($_GET['name']) && !empty($_GET['name'])) {
        $name_nav = $_GET['name'];
        $name_decode = str_replace('---', '+', trim($_GET['name']));
        $temp_var = base64_decode($name_decode);
        $temp_arr = explode("***", $temp_var);
        unset($_GET['name']);
        $check = $db->query_first_slave("
            SELECT COUNT(*) as count
            FROM " . TABLE_PREFIX . "post
            WHERE username = '" . $temp_arr[0] . "' AND ipaddress = '" . $temp_arr[1] . "'
        ");
        if ($check['count'] > 0) {
            $name = $temp_arr[0];
            $ipad = $temp_arr[1];
        } else {   
            $err = 1;
        }
        unset($temp_var);
        unset($temp_arr);
    }
    
    $navbits = array(); 
    $navbits[$parent] = construct_phrase($vbphrase[unregpost_title]);
    
    //to pagenav
    $vbulletin->input->clean_array_gpc('r', array(
            'perpage' => TYPE_INT,
            'page' => TYPE_INT
        ));
    if(empty($vbulletin->GPC['page'])) {
        $page = 1;
    } else {
        $page = $vbulletin->GPC['page'];
    }
    if(empty($vbulletin->GPC['perpage'])) {
        $perpage = 10;
    } else {
        $perpage = $vbulletin->GPC['perpage'];
    }
    
    //load data
    $query = $db->query_read("
        SELECT " . TABLE_PREFIX . "post.postid, " . TABLE_PREFIX . "post.username, " . TABLE_PREFIX . "post.title, " . TABLE_PREFIX . "post.threadid, " . TABLE_PREFIX . "post.dateline,
        " . TABLE_PREFIX . "post.ipaddress, " . TABLE_PREFIX . "post.pagetext, " . TABLE_PREFIX . "thread.title as thread_title,
        " . TABLE_PREFIX . "thread.postusername as author, " . TABLE_PREFIX . "thread.dateline as create_at, " . TABLE_PREFIX . "thread.threadid as thread_id,
        " . TABLE_PREFIX . "postparsed.pagetext_html as text_parsed
        FROM " . TABLE_PREFIX . "post
        LEFT JOIN " . TABLE_PREFIX . "thread ON " . TABLE_PREFIX . "thread.threadid=" . TABLE_PREFIX . "post.threadid
        LEFT JOIN " . TABLE_PREFIX . "postparsed ON " . TABLE_PREFIX . "postparsed.postid=" . TABLE_PREFIX . "post.postid
        WHERE " . TABLE_PREFIX . "post.userid=0 AND " . TABLE_PREFIX . "post.username='" . $name . "' AND " . TABLE_PREFIX . "post.ipaddress='" . $ipad . "' AND " . TABLE_PREFIX . "thread.visible=1
        ORDER BY " . TABLE_PREFIX . "post.dateline DESC
        LIMIT " . (($page-1) * $perpage) . ", " . $perpage . "
    ");
    if ($db->num_rows($query) && (1 != $err)) {
        //if found at least 1 row
        $posts = $authors = $thread_ids = $threads = $dates = array();
        //sort derived data
        for ($i = 0; $i < ($db->num_rows($query)); $i ++) {
            $res = $db->fetch_array($query);
            if (!in_array($res['thread_title'], $threads)) {
                array_push($threads, $res['thread_title']);
                array_push($authors, $res['author']);
                array_push($dates, $res['create_at']);
                array_push($thread_ids, $res['thread_id']);
            }
            $posts[$i]['id'] = $res['postid'];
            $posts[$i]['title'] = $res['title'];
            $posts[$i]['text'] = $res['pagetext'];
            $posts[$i]['date'] = $res['dateline'];
            $posts[$i]['thread'] = $res['threadid'];
            $ipaddress = $res['ipaddress'];
        }
        for ($i = 0; $i < sizeof($threads); $i ++) {
            //for every threads
        
            //prepare date for header template
            $unregpost['theme'] = $threads[$i];
            $unregpost['date'] = date("d.m.Y H:i:s", $dates[$i]);
            $unregpost['author'] = $authors[$i];
            //fetch header template
            eval('$unregpostbits .= "' . fetch_template('unregpost_bits_header') . '";');
            for ($j = 0; $j < sizeof($posts); $j ++) {
                //for every posts
                                
                if ($posts[$j]['thread'] == $thread_ids[$i]) {
                    //preparation post text
                    $text = htmlspecialchars($posts[$j]['text']);
                    //delete all BB-codes
                    $text = preg_replace('/\[.*\].*\[\/.*\]/isU', '', $text);
                    $text = preg_replace('/\[\/.*\]/', '', $text);
                    if (strlen($text) > 150) {
                        $text = substr($text, 0, 150);
                        $text .= '...';
                    }
                    //check title, if title is empty then text of post becom a link to post in forum's thread
                    $reverse = $reverse1 = false;
                    if ('' != $posts[$j]['title']) {
                        $reverse = true;
                    } else {
                        $reverse1 = true;
                    }
                    //prepare date for data template
                    $post_id = $posts[$j]['id'];
                    $post_title = $posts[$j]['title'];
                    $post_date = date("d.m.Y H:i:s", $posts[$j]['date']);
                    $post_text = $text;
                    //fetch data template
                    eval('$unregpostbits .= "' . fetch_template('unregpost_bits') . '";');
                }
            }
        }
        //add pagenav
        $pagenav = construct_page_nav($page, $perpage, $check['count'], "unreg_post.php?name=".$name_nav,"");    
    }
    //add navbar
    $navbits = construct_navbits($navbits);
    eval('$navbar = "' . fetch_template('navbar') . '";');
    //actual main output template
    eval('print_output("' . fetch_template('unreg_post') . '");');
}
?> 